package projecthoneypot::admin;

##  PROJECT HONEY POT MOVABLE TYPE PLUGIN COMPONENT
##  For more information visit: http://www.projecthoneypot.org/
##  Copyright (C) 2004, Unspam, LLC
##  
##  This program is free software; you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation; either version 2 of the License, or
##  (at your option) any later version.
##  
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##  
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
##  02111-1307  USA

use strict;

use MT::App::CMS;
use MT::PluginData;
use vars qw(@ISA $VERSION);
@ISA = qw(MT::App::CMS);
$VERSION = '0.1';

my $hpot_script="";
my ($ehplt,$ehpti,$ehptf) = (1,1,1);
my ($elilp,$etflp,$prefilter) = ("bottom","bottom","__default__");
my $hpls = "";
my $global_warning="";

my($MT_DIR);
BEGIN {
	if ($0 =~ m!(.*[/\\])!) {
		$MT_DIR = $1;
	} else {
		$MT_DIR = './';
	}
}

sub uri {
  $_[0]->path . ($_[0]->{author} ? MT::ConfigMgr->instance->AdminScript : $_[0]->script);
}

sub init {
	use MT::FileMgr;

	my $app = shift;
	$app->SUPER::init (@_) or return;
		
	$app->add_methods (
		adm => \&admin,
		nwu => \&new_user,
		lkf => \&link_formats,
		gns => \&general_settings,
		err => \&error_page
	);
	
	$app->{default_mode} = 'adm';
	my $mode = $app->{query}->param('__mode');

	my $fmgr = MT::FileMgr->new('Local') or warn MT::FileMgr->errstr;
	if ($mode ne "err") {
		if (!$fmgr->exists($MT_DIR.'/plugins/projecthoneypot.pl') || !$fmgr->exists($MT_DIR.'/plugins/projecthoneypot/admin.pm') || !$fmgr->exists($MT_DIR.'/tmpl/cms/projecthoneypot.tmpl') || !$fmgr->exists($MT_DIR.'/plugins/projecthoneypot/link_formats.conf')) {
			$app->redirect('http://www.projecthoneypot.org/mt_error.php');
		}
		
		my ($pdata) = MT::PluginData->load({ plugin => 'mt-projecthoneypot', key => 'phpot_plugin' });
		if ($pdata) {
			my $data_holder = $pdata->data;
			my $do_save = $app->{query}->param('do_save') || 0;
			if ($do_save) {
				if ($do_save eq "gns") {
					$global_warning .= $app->{query}->param('elilp').$app->{query}->param('etflp');
					$data_holder->{'global_filter'} = $app->{query}->param('ehpti') || 0;
					$data_holder->{'text_filter'} = $app->{query}->param('ehptf') || 0;
					$data_holder->{'honeypot_tag'} = $app->{query}->param('enplt') || 0;
					$data_holder->{'linkinsert_default'} = $app->{query}->param('elilp') || 0;
					$data_holder->{'textfilter_default'} = $app->{query}->param('etflp') || 0;
					$data_holder->{'prefilter'} = $app->{query}->param('prefilter') || 0;
					my $list_of_filters = MT->all_text_filters;
					$data_holder->{'prefilter_label'} = $list_of_filters->{$data_holder->{'prefilter'}}{label};
				}
				if ($do_save eq "lkf") {
					my $link_patterns = $app->{query}->param('total_patterns') || 0;
					my $pattern_format = "";
					for (my $i=0;$i<(int($link_patterns));$i++) {
						if ($app->{query}->param('pattern_'.$i)) {
							$pattern_format .= "1:";
						} else {
							$pattern_format .= "0:";
						}
					}
					chop($pattern_format);
					$data_holder->{'link_patterns'} = $pattern_format;
				}
				$pdata->data($data_holder);
				$pdata->save or die $pdata->errstr;
			}
			$hpot_script = $data_holder->{'script_location'};
			$ehpti = $data_holder->{'global_filter'};
			$ehptf = $data_holder->{'text_filter'};
			$ehplt = $data_holder->{'honeypot_tag'};
			$elilp = $data_holder->{'linkinsert_default'};
			$etflp = $data_holder->{'textfilter_default'};
			$prefilter = $data_holder->{'prefilter'};
			$hpls = $data_holder->{'link_patterns'};
			if ($hpot_script) {
				if (!$fmgr->exists($MT_DIR.$hpot_script)) {
					$hpot_script = &find_hpot_script();
					if ($hpot_script) {
						$data_holder->{'script_location'} = $hpot_script;
						$pdata->data($data_holder);
						$pdata->save or die $pdata->errstr;
					} else {
						$pdata->remove or die $pdata->errstr;
					}
				}
			}
		}
		if (!$hpot_script) {
			$hpot_script = &find_hpot_script();
			if ($hpot_script) {
				my $data = MT::PluginData->new;
				my $data_holder;
				$data_holder->{'script_location'} = $hpot_script;
				$data_holder->{'global_filter'} = 1;
				$data_holder->{'text_filter'} = 1;
				$data_holder->{'honeypot_tag'} = 1;
				$data_holder->{'linkinsert_default'} = "bottom";
				$data_holder->{'textfilter_default'} = "bottom";
				$data_holder->{'prefilter'} = "__default__";
				my $list_of_filters = MT->all_text_filters;
				$data_holder->{'prefilter_label'} = $list_of_filters->{$data_holder->{'prefilter'}}{label};
				$data_holder->{'link_patterns'} = &get_default_patterns();
				$data->plugin('mt-projecthoneypot'); 
				$data->key('phpot_plugin');
				$data->data($data_holder);
				$data->save or die $data->errstr;
			}
		}
		
		if ($hpot_script && ($mode eq "nwu")) {
			$app->redirect($app->path.'mt-projecthoneypot.cgi?__mode=adm');
		}
		
		if (!$hpot_script && ($mode ne "nwu")) {
			$app->redirect($app->path.'mt-projecthoneypot.cgi?__mode=nwu');
		}
	}
		
	$app->{requires_login} = 1 ;
	$app->{user_class} = 'MT::Author';
	$app->{breadcrumbs} = [ { bc_name => 'Main Menu', bc_uri => 'mt.cgi' } ];
	if ($app->can('add_breadcrumb')) { $app->add_breadcrumb('Project Honey Pot MT Plugin', '?__mode=adm'); }
	$app->{is_admin} = 1;
	$app;
}

sub get_default_patterns {
	my $patterns_string = "";
	my $line_count = 0;
	if (open (PATTERNS, "$MT_DIR/plugins/projecthoneypot/link_formats.conf")) {
		my @patterns = <PATTERNS>;
		foreach my $pattern (@patterns) {
			$pattern =~ m/^\[\!(.*)\!\]/;
			if ($1 eq "1") {
				$patterns_string .= "1:";
			} else {
				$patterns_string .= "0:";
			}
		}
		chop($patterns_string);
		close(PATTERNS);
	}
	return $patterns_string;
}

sub find_hpot_script {
	opendir(DIR,"$MT_DIR") or die "Cannot open the MT script directory.";
	my ($file,$text);
	DIRLOOP: while ($file = readdir(DIR)) {
    	next DIRLOOP unless ($file =~ /^.*\.cgi$/);
    	open (TEMP, $MT_DIR.$file);
    	FILELOOP: while ($text = <TEMP>) {
			if ($text =~ /BwkejKAi2hjklasdkl230aiojWERMNqwekn2kASK2jalasjhbeqm2bnash/) {
				close(TEMP);
				closedir(DIR);
            	return $file;
			}
		}
		close(TEMP);
	}
	closedir(DIR);
	return 0;
}

## Pages generated below.

sub link_formats {
	my $app = shift;
	my $line_counter = 0;
	my $form_data = "<p>";
	if (open (PATTERNS, "$MT_DIR/plugins/projecthoneypot/link_formats.conf")) {
		my @patterns = <PATTERNS>;
		my $pattern = "";
		close(PATTERNS);
		my @pattern_settings = split(/:/, $hpls);
		foreach my $toggle (@pattern_settings) {
			$pattern = $patterns[$line_counter];
			chomp($pattern);
			$pattern =~ s/^\[\![a-zA-Z0-9\:\;\.\,\-\_\+\= ]*\!\][ ]*//g;
			if ($pattern) {
				$pattern =~ s/\</\&lt;/g;
				$pattern =~ s/\>/\&gt;/g;
				if ($toggle) {
					$form_data .= "<b>#".($line_counter+1)."</b>&nbsp;<input type='checkbox' name='pattern_$line_counter' value='1' checked />&nbsp;$pattern<br />\n";
				} else {
					$form_data .= "<b>#".($line_counter+1)."</b>&nbsp;<input type='checkbox' name='pattern_$line_counter' value='1' />&nbsp;$pattern<br />\n";
				}
				$line_counter++;
			}
		}
		$form_data .= "</p>";
	}

	my %param = (	func_lkf => 1, 
					form_checkboxes => $form_data,
					total_patterns => $line_counter,
					mt_dir => $MT_DIR,
					phpot_plugin_version=>$VERSION 
				);
	
	if ($app->can('add_breadcrumb')) { $app->add_breadcrumb('Link Formats', '?__mode=nta'); }
	$app->build_page('projecthoneypot.tmpl', \%param);
}

sub general_settings {
	my $app = shift;
	
	my $filter_pulldown = "";
	my $filters = MT->all_text_filters;
	my $selected_prefilter = "";
	for my $filter (keys %$filters) {
		if ($filter ne "phpot_textfilter") {
			if ($filter eq $prefilter) { $selected_prefilter = " selected"; } else { $selected_prefilter = ""; }
			$filter_pulldown .= "<option value='$filter'$selected_prefilter>".$filters->{$filter}{label}."</option>";
		}
	}
	my %ehpli_param = ();
	$ehpli_param{$elilp} = 1;
	my %ehptf_param = ();
	$ehptf_param{$etflp} = 1;

	my %param = (	func_gns => 1,
					func_ehpti => $ehpti,
					func_ehplt => $ehplt,
					func_ehptf => $ehptf,
					filter_pulldown => $filter_pulldown,
					li_top => $ehpli_param{'top'},
					li_bottom => $ehpli_param{'bottom'},
					li_random => $ehpli_param{'random'},
					tf_top => $ehptf_param{'top'},
					tf_bottom => $ehptf_param{'bottom'},
					tf_random => $ehptf_param{'random'},
					phpot_plugin_version=>$VERSION
				);
	
	if ($app->can('add_breadcrumb')) { $app->add_breadcrumb('General Settings', '?__mode=mea'); }
	$app->build_page('projecthoneypot.tmpl', \%param);
}

sub admin {
	my $app = shift;

	my $script_url = "http://".$ENV{SERVER_NAME}.$app->path.$hpot_script;
	my $save_alert = $app->{query}->param('do_save') || 0;
	
	my %param = (	func_adm => 1, 
					phpot_plugin_version=>$VERSION,
					func_save => $save_alert,
					func_ehpti => !$ehpti,
					func_ehplt => !$ehplt,
					func_ehptf => !$ehptf,
					script_location=>$script_url
				);
	$app->build_page('projecthoneypot.tmpl', \%param);
}

sub new_user {
	my $app = shift;
	
	use MT::Author;
	my $perl_path = `which perl`;
	chomp($perl_path);
	my $script_url = "http://".$ENV{SERVER_NAME}.$app->path;
	my $website_url = $ENV{SERVER_NAME};
	my $user_email = $app->{cfg}->EmailAddressMain;
	my $mt_script_dir = $MT_DIR;
	my %param = (	func_nwu => 1,
					phpot_plugin_version=>$VERSION,
					website_url=>$website_url,
					script_url=>$script_url,
					email=>$user_email,
					version=>$VERSION,
					fingerprint=>'Hwkmma398SDFKLJasl2LKJSDnamsdlkj3asdoiuk2lkAKjas8hdfa',
					mt_script_dir=>$mt_script_dir,
					perl_path=>$perl_path
				);
	$app->build_page('projecthoneypot.tmpl', \%param);
}

sub error_page {
	my $app = shift;
	
	my ($pdata) = MT::PluginData->load({ plugin => 'mt-projecthoneypot', key => 'phpot_plugin' });
	$pdata->remove or die $pdata->errstr;
	
	my %param = (func_err => 1, phpot_plugin_version=>$VERSION);
	$app->build_page('projecthoneypot.tmpl', \%param);
}